﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="RaterWithRatingPanelAndValidation.aspx.cs" Inherits="RaterWithRatingPanelAndValidation" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>RaterWithRatingPanelAndValidation</title>

    <style type="text/css">
        .emphasized-text { font-family: 'Segoe UI', Trebuchet MS, Tahoma, Arial; font-weight:bold}
        .validator { color: #FF0000; font-weight: bold; font-size: 11pt; }
    </style>
    
    <script type="text/javascript" language="javascript">
        var ratingTitles = new Array();
        ratingTitles[1] = 'Not Useful';
        ratingTitles[2] = 'Needs Improvement';
        ratingTitles[3] = 'OK';
        ratingTitles[4] = 'Good';
        ratingTitles[5] = 'Excellent';

        function RadRating_OnClientLoad(rating, args) {
            setRadRatingStarTitles(rating);
            var element = rating.get_element();
            var ul = element.children[0];
            if (ul.tagName.toLowerCase() != "ul") ul = element.children[1];
            if (ul.tagName.toLowerCase() == "ul") {
                for (var i = 0; i < ul.children.length; i++) {
                    var anchor = ul.children[i].children[0];
                    $addHandler(anchor, "mouseover", UpdateCourseRatingText);
                    $addHandler(anchor, "mouseout", ClearCourseRatingText);
                }
            } else {
                alert('anchor for star spans not found!');
            }
        }
        
        function RadRating_OnClientRated(rating, args) {
            var element = rating.get_element();
            var ratingID = element.id;
            var spanOverName = ratingID + 'SpanOver';
            var spanRatedName = ratingID + 'SpanRated';
            var validatorName = ratingID + 'CV';
            $get(validatorName).style.display = 'none';
            $get(spanRatedName).style.display = '';
            $get(spanOverName).style.display = 'none';
            $get(spanOverName).innerHTML = '';
            var items = rating._items;
            $get(spanRatedName).innerHTML = ratingTitles[rating.get_value()];
        }
        
        function ClearCourseRatingText(e) {
            var spanOverName;
            var spanRatedName;
            var target = (e.target || e.srcElement);
            if (target.tagName.toLowerCase() == "span") {
                spanOverName = target.parentNode.parentNode.parentNode.parentNode.id + 'SpanOver';
                spanRatedName = target.parentNode.parentNode.parentNode.parentNode.id + 'SpanRated';
            }
            else if (target.tagName.toLowerCase() == "a") {
                spanOverName = target.parentNode.parentNode.parentNode.id + 'SpanOver';
                spanRatedName = target.parentNode.parentNode.parentNode.id + 'SpanRated';
            } else {
                return;
            }
            var index = target.innerHTML.toLowerCase().replace('<span>', '');
            index = index.replace('</span>', '');
            $get(spanRatedName).style.display = '';
            $get(spanOverName).style.display = 'none';
            $get(spanOverName).innerHTML = '';
        }
        
        function UpdateCourseRatingText(e) {
            var index;
            var spanOverName;
            var spanRatedName;
            var target = (e.target || e.srcElement);
            if (target.tagName.toLowerCase() == "span") {
                spanOverName = target.parentNode.parentNode.parentNode.parentNode.id + 'SpanOver';
                spanRatedName = target.parentNode.parentNode.parentNode.parentNode.id + 'SpanRated';
                index = target.innerHTML;
            } else if (target.tagName.toLowerCase() == "a") {
                spanOverName = target.parentNode.parentNode.parentNode.id + 'SpanOver';
                spanRatedName = target.parentNode.parentNode.parentNode.id + 'SpanRated';
                index = target.innerHTML.toLowerCase().replace('<span>', '');
                index = index.replace('</span>', '');
            } else {
                return;
            }
            $get(spanRatedName).style.display = 'none';
            $get(spanOverName).style.display = '';
            $get(spanOverName).innerHTML = ratingTitles[index];
        }
        
        function setRadRatingStarTitles(rating) {
                var items = rating._items;
                items[0].children[0].title = ratingTitles[1];
                items[1].children[0].title = ratingTitles[2];
                items[2].children[0].title = ratingTitles[3];
                items[3].children[0].title = ratingTitles[4];
                items[4].children[0].title = ratingTitles[5];
            }
        
        function ValidateRating(source, args) {
            var ratingID = source.id.substring(0, source.id.length - 2);
            var rating = $find(ratingID);
            if (rating.get_value() > 0)
                args.IsValid = true;
            else
                args.IsValid = false;
        }

    </script>

</head>
<body>
    <form id="form1" runat="server">
    <div>
        <telerik:RadScriptManager ID="radScriptManager" runat="server" />
        <table border="0">
            <tr>
                <td>
                    <telerik:RadRating ID="radRatingCourse" runat="server" EnableToolTips="false"
                        OnClientLoad="RadRating_OnClientLoad" OnClientRated="RadRating_OnClientRated" />
                </td>
                <td>
                    <span runat="server" id="radRatingCourseSpanOver" style="display: none" class="emphasized-text">
                    </span><span runat="server" id="radRatingCourseSpanRated" class="emphasized-text"></span>
                </td>
                <td>
                    &nbsp;<asp:CustomValidator runat="server" CssClass="validator" ID="radRatingCourseCV"
                        ClientValidationFunction="ValidateRating" ErrorMessage="Please click on at least 1 star!" />
                </td>
            </tr>
        </table>
        <br />
        <br />
        <input type="submit" runat="server" value="Submit" />
    </div>
    </form>
</body>
</html>
